

//фьюзы Ext=0xFD H=D9 L=FF
#include <SPI.h>
#include <Wire.h>
#include <EEPROM.h>

// For the Adafruit shield, these are the default.
// Use hardware SPI (on Uno, #13, #12, #11) and the above for CS/DC
// If using the breakout, change pins as desired
// 1 TFT_VCC -> 3V3 // это для моего дисплея
// 2 TFT_GND -> GND
// 3 TFT_CS  -> D10 //через резистор 1кОм
// 4 TFT_RST -> RST_pin // на D8 не работает повесил на RST через резистор 1кОм
// 5 TFT_DC  -> D9  //через резистор 1кОм
// 6 TFT_MOSI-> D11 //через резистор 1кОм
// 7 TFT_SCK -> D13 //через резистор 1кОм
// 8 TFT_LED -> 3V3
// 9 TFT_MISO-> N.C.//D12 - не надо
#include <Adafruit_GFX.h>
#include <Adafruit_ILI9341.h>
#define TFT_DC 9
#define TFT_CS 10
#define Bgcolor 0xC618
#define ILI9341_NAVY            0x000F 
#define ILI9341_DARKGREEN       0x03E0 
//Adafruit_ILI9341 tft = Adafruit_ILI9341(TFT_CS, TFT_DC);
Adafruit_ILI9341 tft = Adafruit_ILI9341();

//------------
 double max6675_read_temp (int CLK, int CS, int SO)            
{ char i;
    int tmp = 0;
   digitalWrite(CS, LOW);//CS = 0;                            // Stop a conversion in progress
   asm volatile
    (
     " nop"        "\n\t"
    );
   for (i=15;i>=0;i--)
    {  digitalWrite(CLK, HIGH);
      asm volatile
    (
     " nop"        "\n\t"
    );
      if( digitalRead(SO))
      tmp|=(1<<i);
   
 
      digitalWrite(CLK, LOW);
    asm volatile
    (
     " nop"        "\n\t"
    );
    }
   digitalWrite(CS, HIGH);
   if (tmp & 0x4) {
     return NAN;
   } else
   return ((tmp>>3))*0.25;
}
//-------------

// #include <max6675.h>
//назначаем пины усилителя термопары 
#define thermoSO        4 //DO
#define thermoCLK       5 //SCK
#define thermoCStop     6 //CS MAX6675 "ВЕРХНЕГО" нагревателя
#define thermoCSbott    7 //CS MAX6675 "НИЖНЕГО" нагревателя

// MAX6675 thermocouple1(max6675_read_temp (thermoCLK, thermoCStop, thermoSO)); //термопара "ВЕРХНЕГО" нагревателя
// MAX6675 thermocouple2(max6675_read_temp (thermoCLK, thermoCSbott, thermoSO)); //термопара "НИЖНЕГО"  нагревателя

#define buzzerPin   0
#define UP_Pin     A0  //Назначаем пины кнопок управления
#define DN_Pin     A1
#define ESC_Pin    A2
#define OK_Pin     A3
#define RelayPin1  A4  //назначаем пин "ВЕРХНЕГО" нагревателя
#define RelayPin2  A5  //назначаем пин "НИЖНЕГО" нагревателя*/

#include "s_button.h" //обработчик кнопок (button_5)
uint16_t holdTime = 2000; // ms длительность нажатия + удержания
uint16_t debounce = 50;   // ms антидребезг
SButton UP_KEY (UP_Pin,  debounce);
SButton DN_KEY (DN_Pin,  debounce);
SButton ESC_KEY(ESC_Pin, debounce, holdTime);
SButton OK_KEY (OK_Pin,  debounce, holdTime);

#include "PID_v1.h"
uint8_t WindowSize = 200;//500
unsigned long windowStartTime;
double kp1 = 3;
double ki1 = 1; //потом делим на 10
double kd1 = 20;
double kp2 = 3;
double ki2 = 1; //потом делим на 10
double kd2 = 20;
double Setpoint1 = 200, Input1, Output1;//Specify the links and initial tuning parameters
double Setpoint2 = 120, Input2, Output2;//Specify the links and initial tuning parameters
PID myPID1(&Input1, &Output1, &Setpoint1, kp1, ki1, kd1, P_ON_M, DIRECT);
PID myPID2(&Input2, &Output2, &Setpoint2, kp2, ki2, kd2, P_ON_M, DIRECT);
 //P_ON_M specifies that Proportional on Measurement be used
 //P_ON_E (Proportional on Error) is the default behavior

boolean alarmOn = false;//Alarm state boolean
boolean updateScreen = true;//Update whole screen boolean
uint8_t curCount = 0;
uint8_t editStep = 0;//current editing step pointer
uint8_t currentProfile = 1;
uint8_t currentStep = 1;
uint8_t profileSteps = 2;
uint8_t counter;//double
long previousMillis; //это для счетчиков

double rampRateStep[9] = {4, 1, 1, 1, 1, 1, 1, 1, 1};
uint8_t dwellTimerStep[9];
uint16_t setpointRamp = 240;
double startTemp;
boolean TopStart = false;
boolean flag = 0;  //флаг для фиксации стартовой температуры
uint8_t x=1;  //переменная для перехода на нужный шаг при горячей плате
uint16_t temperatureStep[9] = {200, 205, 210, 220, 225, 230, 235, 240, 245};

volatile boolean beeper_on = false;

uint8_t eepromAddress = 0; //начало eepromaddress
uint16_t SENSOR_SAMPLING_TIME = 1000; //частота обновления текущей температуры (1000=1раз в секунду)
uint16_t GRAPHICS_SAMPLING_TIME = 500; //скорость движения "звёздочек" при пайке

//TC read timer variables
unsigned long nextCheck1;
unsigned long nextRead1;//переменная для обновления текущей температуры
unsigned long nextRead2;//переменная для движения "звёздочек" при пайке

//profile stuff
uint8_t er1=1;
uint8_t er2=1;
uint8_t reg1;
uint8_t reg2;
volatile boolean out1;
volatile boolean out2;
uint8_t pwr_BOTTOM = 50;  //максимальная мощность нижнего нагревателя
uint8_t pwr_TOP = 100;     //максимальная мощность верхнего нагревателя

/*
// переменные для калмана "ВЕРХНЕГО" нагревателя
float varTerm1 = 0.35;  // среднее отклонение (ищем в excel)
float varProcess1 = 0.1; // скорость реакции на изменение (подбирается вручную)
float Pc1 = 0.0;
float G1 = 0.0;
float P1 = 1.0;
float Xp1 = 0.0;
float Zp1 = 0.0;
float Xe1 = 0.0;

// переменные для калмана "НИЖНЕГО" нагревателя
float varTerm2 = 0.35;  // среднее отклонение (ищем в excel)
float varProcess2 = 0.1; // скорость реакции на изменение (подбирается вручную)
float Pc2 = 0.0;
float G2 = 0.0;
float P2 = 1.0;
float Xp2 = 0.0;
float Zp2 = 0.0;
float Xe2 = 0.0;
*/

uint16_t tc1, tc1_gr;
uint16_t tc2, tc2_gr;
//uint16_t tc1_old;
//uint16_t tc2_old;

uint16_t i = 0;

//these are the different states of the sketch. We call different ones depending on conditions
// ***** TYPE DEFINITIONS *****
typedef enum REFLOW_STATE
{
  REFLOW_STATE_IDLE,
  REFLOW_STATE_MENU_BOTTOM_HEAT,//REFLOW_STATE_MENU_STEPS,
  REFLOW_STATE_MENU_BOTTOM_PWR,//REFLOW_STATE_MENU_BOTTOM_HEAT,
  REFLOW_STATE_MENU_TOP_PWR,//REFLOW_STATE_MENU_BOTTOM_PWR,
  REFLOW_STATE_MENU_STEPS,//REFLOW_STATE_MENU_STEP_RAMP,
  REFLOW_STATE_MENU_STEP_TARGET,//REFLOW_STATE_MENU_STEP_TARGET,
  REFLOW_STATE_MENU_STEP_RAMP,//REFLOW_STATE_MENU_TOP_PWR,
  REFLOW_STATE_MENU_STEP_DWELL,
  REFLOW_STATE_MENU_BOTTOM_P,
  REFLOW_STATE_MENU_BOTTOM_I,
  REFLOW_STATE_MENU_BOTTOM_D,
  REFLOW_STATE_MENU_TOP_P,
  REFLOW_STATE_MENU_TOP_I,
  REFLOW_STATE_MENU_TOP_D,
  REFLOW_STATE_STEP_RAMP,
  REFLOW_STATE_STEP,
  REFLOW_STATE_STEP_DWELL,
  REFLOW_STATE_COMPLETE,
  REFLOW_STATE_ERROR
}
reflowState_t;
reflowState_t reflowState;

typedef enum REFLOW_STATUS //this is simply to check if reflow should be running or not
{
  REFLOW_STATUS_OFF,
  REFLOW_STATUS_ON
}
reflowStatus_t;
reflowStatus_t reflowStatus;// Reflow oven controller state machine state variable

#include "disp.h"

uint8_t ed_pid = 0;
bool case0 = false;
bool case1 = false;
bool case2 = false;
bool case3 = false;
bool case4 = false;
bool case5 = false;

////////////////////////////////////////////////
////////////////////////////////////////////////
////////////////////////////////////////////////
void setup()
{
  tft.begin();
  tft.setRotation(3);
  tft.setTextWrap(false); // отменить перенос строк
  tft.fillRect(0, 0, w, h, Bgcolor);//lcd.clear();  
  tft.setTextColor(ILI9341_NAVY);  tft.setTextSize(4);
  tft.setCursor(5, 5);
  tft.print("ARS NANO v1m5");
  tft.setCursor(col_5(2), row_5(2));
  tft.setTextColor(ILI9341_DARKGREEN);
  tft.print("REWORK");
  tft.setCursor(col_5(2), row_5(4));
  tft.print("STATION");
  tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);

  // colors of ILI9341
  // ILI9341_BLACK       0x0000      /*   0,   0,   0 */
  // ILI9341_NAVY        0x000F      /*   0,   0, 128 */
  // ILI9341_DARKGREEN   0x03E0      /*   0, 128,   0 */
  // ILI9341_DARKCYAN    0x03EF      /*   0, 128, 128 */
  // ILI9341_MAROON      0x7800      /* 128,   0,   0 */
  // ILI9341_PURPLE      0x780F      /* 128,   0, 128 */
  // ILI9341_OLIVE       0x7BE0      /* 128, 128,   0 */
  // ILI9341_LIGHTGREY   0xC618      /* 192, 192, 192 */
  // ILI9341_DARKGREY    0x7BEF      /* 128, 128, 128 */
  // ILI9341_BLUE        0x001F      /*   0,   0, 255 */
  // ILI9341_GREEN       0x07E0      /*   0, 255,   0 */
  // ILI9341_CYAN        0x07FF      /*   0, 255, 255 */
  // ILI9341_RED         0xF800      /* 255,   0,   0 */
  // ILI9341_MAGENTA     0xF81F      /* 255,   0, 255 */
  // ILI9341_YELLOW      0xFFE0      /* 255, 255,   0 */
  // ILI9341_WHITE       0xFFFF      /* 255, 255, 255 */
  // ILI9341_ORANGE      0xFD20      /* 255, 165,   0 */
  // ILI9341_GREENYELLOW 0xAFE5      /* 173, 255,  47 */
  // ILI9341_PINK        0xF81F

  pinMode(buzzerPin, OUTPUT);
  pinMode(RelayPin1, OUTPUT);//реле
  pinMode(RelayPin2, OUTPUT);
  pinMode(2, INPUT_PULLUP);//ZCC

  //----------------------
  pinMode(thermoCStop, OUTPUT);
  pinMode(thermoCSbott, OUTPUT);
  pinMode(thermoCLK, OUTPUT);
  pinMode(thermoSO, INPUT);
  //----------------------
  
  /////////////////////////////////////////////
  saveProfile();
  /////////////////////////////////////////////


  //Мелодия приветствия
  if (beeper_on)
  {
   tone(buzzerPin, 523, 200);
   tone(buzzerPin, 659, 200);
   tone(buzzerPin, 784, 200);
   tone(buzzerPin, 1046, 200);
  }

  myPID1.SetOutputLimits(0, 100);//myPID1 = top heater PID loop
  myPID2.SetOutputLimits(0, 100);
  myPID1.SetMode(AUTOMATIC);
  myPID2.SetMode(AUTOMATIC);
  myPID1.SetSampleTime(50); //задает частоту расчета выходного сигнала в милисекундах
  myPID2.SetSampleTime(50);

  UP_KEY.begin();
  DN_KEY.begin();
  ESC_KEY.begin();
  OK_KEY.begin();

  // wait for MAX chips to stabilize and splash screen
  delay(500);
  
  windowStartTime = millis();//Just total time sketch has been running
  // Initialize time keeping variable for TC1
  nextCheck1 = millis();  // Initialize  top thermocouple reading variable
  nextRead1 = millis();   //initialize soak timer variable

}



void setka()
{
  for( uint16_t str = 0; str <= (h/yc); str++)
  {
    tft.drawFastHLine(0, str*yc, w, ILI9341_GREEN);
  }
  for( uint16_t col = 0; col <= (w/xc); col++)
  {
    tft.drawFastVLine(col*xc, 0, h, ILI9341_GREEN);
  }
}
void cls()
{
  tft.fillRect(0, font5step_y, w, h-font5step_y, Bgcolor);//lcd.clear();
  //setka();
}







void loop()
{
  unsigned long currentMillis = millis(); 
  uint16_t SP1 = Setpoint1;
  uint16_t SP2 = Setpoint2;

reflow_complete_ok();

switch (reflowState)
{
case REFLOW_STATE_IDLE:
      TopStart = false;
      currentStep = 1;
      counter = 0;
      setpointRamp = 0;
      x = 1;             //устанавливаем переменную в исходное состояние
      flag = 0;         //после отановки профиля сбрасываем флаг
      Output1=0;
      Output2=0;
      gx = 21;


      if (millis() > nextRead1)
      {
        nextRead1 += SENSOR_SAMPLING_TIME;// Read thermocouples next sampling period
        // Input1 = thermocouple1.readCelsius();
        // Input2 = thermocouple2.readCelsius();
        Input1 = max6675_read_temp (thermoCLK, thermoCStop, thermoSO);
        Input2 = max6675_read_temp (thermoCLK, thermoCSbott, thermoSO);
        tc1 = Input1;
        tc2 = Input2;
        tc1_gr = (tc1 < 299) ? tc1 : 299;
        tc2_gr = (tc2 < 299) ? tc2 : 299;

      }
      
      if (updateScreen) { //Update whole screen only once
        loadProfile();//call the loadProfile function to load from eeprom
        cls();//Настройка экрана в режиме ожидания
        tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
        tft.setCursor(col(mode_x), row(mode_y));
        tft.print("IDLE");//
        tft.setCursor(col(1), row(4));
        tft.print("PTN:");
        tft.setCursor(col(5), row(4));
        tft.print(currentProfile);
        tft.setCursor(col(9), row(4));
        tft.print("STEPS:"); 
        tft.setCursor(col(15), row(4));
        tft.print(profileSteps);//"1");//currentStep
        //tft.setCursor(col(10), row(4));
        //tft.print("STEP:"); tft.print("1");//currentStep
        tft.setCursor(col(1), row(6));
        tft.print("TH=");
        tft.setCursor(col(4), row(6));
        tft.print(temperatureStep[0]);// tft.print("  ");
        tft.setCursor(col(10), row(6));
        tft.print(char(30));tft.print("T=");
        tft.setCursor(col(1), row(8));
        tft.print("BH=");
        tft.setCursor(col(10), row(8));
        tft.print(char(31));tft.print("T=");
        tft.setCursor(col(4), row(8));
        tft.print(SP2); tft.print(" ");
        updateScreen = false;
      }
      tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
      tft.setCursor(col(5), row(4));
      tft.print(currentProfile);
      tft.setCursor(col(4), row(6));
      tft.print(temperatureStep[currentProfile-1]); tft.print("  ");
      tft.setCursor(col(4), row(8));
      tft.print(SP2); tft.print("  ");
      tft.setCursor(col(tc_x), row(tc1_y));
      tft.print(tc1); tft.print("  ");
      tft.setCursor(col(tc_x), row(tc2_y));
      tft.print(tc2); tft.print("  ");
      
      windowStartTime = millis();

      if ( UP_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (++currentProfile >= 5) { currentProfile = 1; }
      }
      if ( DN_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (--currentProfile <= 0) { currentProfile = 4; }
      }
    //фиксируем момент нажатия кнопки "ОК" + защита от дребезга
      switch ( OK_KEY.isPressed() )
      {
        case SB_CLICK: // старт профиля
          tone(buzzerPin, 1045, 500);  //звуковой сигнал при старте профиля
          updateScreen = true;//update next screen
          curCount = 0;
          nextRead2 = millis();
          reflowStatus = REFLOW_STATUS_ON;
          reflowState = REFLOW_STATE_STEP_RAMP;
          break;
        case SB_LONG_CLICK: //меню настроек
          beeper();
          reflowState = REFLOW_STATE_MENU_BOTTOM_HEAT;
          updateScreen = true;//update next screen
          break;
      }
      switch ( ESC_KEY.isPressed() )
      {
        case SB_CLICK: // что-то делаем при нажатии ESC
          beeper();
          break;
        case SB_LONG_CLICK: // что-то делаем при долгом нажатии ESC
          beeper();
          break;
      }
break;

//устанавливаем температуру "Нижнего Нагревателя"
case REFLOW_STATE_MENU_BOTTOM_HEAT:

      if (updateScreen)
      {
        cls();
        tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
        tft.setCursor(col(mode_x), row(mode_y)); //x=7,y=2
        tft.print("SETUP");
        tft.setCursor(col(1), row(6));
        tft.print("Bottom T=         ");
        updateScreen = false;
      }
      tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
      tft.setCursor(col(10), row(6));
      tft.print(SP2); tft.print(char(128)); tft.print("C  ");

      switch (UP_KEY.isPressed())
      {
      case SB_CLICK:
        beeper();
        Setpoint2 += 5;
        if (Setpoint2 >= 250) Setpoint2 = 250;
        break;
      case SB_AUTO_CLICK:
        Setpoint2 += 5;
        if (Setpoint2 >= 250) Setpoint2 = 250;
        break;
      }
      /*
      if ( UP_KEY.isPressed() == SB_CLICK) {
        beeper();
        Setpoint2 += 5;
        //Setpoint2 = Setpoint2 + 5;
        if (Setpoint2 >= 250) { Setpoint2 = 250; }
      }
      */
      switch (DN_KEY.isPressed())
      {
      case SB_CLICK:
        beeper();
        Setpoint2 -= 5;
        if (Setpoint2 <= 30) Setpoint2 = 30;
        break;
      case SB_AUTO_CLICK:
        Setpoint2 -= 5;
        if (Setpoint2 <= 30) Setpoint2 = 30;
        break;
      }
      /*
      if ( DN_KEY.isPressed() == SB_CLICK) {
        beeper();
        Setpoint2 -= 5;
        //Setpoint2 = Setpoint2 - 5;
        if (Setpoint2 <= 30) { Setpoint2 = 30; }
      }
      */

      if ( OK_KEY.isPressed() == SB_CLICK)  {        
        beeper();
        updateScreen = true;
        saveProfile();
        reflowState = REFLOW_STATE_MENU_BOTTOM_PWR;
      }
      if ( ESC_KEY.isPressed() == SB_CLICK) {
        CancelState();
      }
      break;

//устанавливаем максимальную мощность "НИЖНЕГО НАГРЕВАТЕЛЯ"     
case REFLOW_STATE_MENU_BOTTOM_PWR:
      if (updateScreen)
      {
        tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
        tft.setCursor(col(1), row(6));
        tft.print("Bottom PWR=      ");    
        updateScreen = false;
      }
      tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
      tft.setCursor(col(12), row(6));
      tft.print(pwr_BOTTOM);  tft.print("%  ");
      
      switch (UP_KEY.isPressed())
      {
      case SB_CLICK:
        beeper();
        if (++pwr_BOTTOM >= 100) pwr_BOTTOM = 100;
        break;
      case SB_AUTO_CLICK:
        if (++pwr_BOTTOM >= 100) pwr_BOTTOM = 100;
        break;
      }
      /*
      if ( UP_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (++pwr_BOTTOM >= 100) { pwr_BOTTOM = 100; }
      }
      */
      switch (DN_KEY.isPressed())
      {
        case SB_CLICK:
          beeper();
          if (--pwr_BOTTOM <= 0) pwr_BOTTOM = 0;
          break;
        case SB_AUTO_CLICK:
          if (--pwr_BOTTOM <= 0) pwr_BOTTOM = 0;
          break;
      }
      /*
      if ( DN_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (--pwr_BOTTOM <= 0) { pwr_BOTTOM = 0; }
      }
      */

      if ( OK_KEY.isPressed() == SB_CLICK)
      {        
        beeper();
        updateScreen = true;
        saveProfile();
        reflowState = REFLOW_STATE_MENU_TOP_PWR;
      }
      if ( ESC_KEY.isPressed() == SB_CLICK)
      {
         CancelState();
      }
      break;


 //устанавливаем максимальную мощность "ВЕРХНЕГО НАГРЕВАТЕЛЯ"      
case REFLOW_STATE_MENU_TOP_PWR:
      if (updateScreen)
      {   
        tft.setTextColor(ILI9341_RED, Bgcolor);
        tft.setCursor(col(1), row(6));
        tft.print("   TOP PWR=         ");
        updateScreen = false;
      }
      tft.setTextColor(ILI9341_RED, Bgcolor);
      tft.setCursor(col(12), row(6));
      tft.print(pwr_TOP);  tft.print("%  ");

      switch (UP_KEY.isPressed())
      {
      case SB_CLICK:
        beeper();
        if (++pwr_TOP >= 100) pwr_TOP = 100;
        break;
      case SB_AUTO_CLICK:
        if (++pwr_TOP >= 100) pwr_TOP = 100;
        break;
      }
      switch (DN_KEY.isPressed())
      {
      case SB_CLICK:
        beeper();
        if (--pwr_TOP <= 0) pwr_TOP = 0;
        break;
      case SB_AUTO_CLICK:
        if (--pwr_TOP <= 0) pwr_TOP = 0;
        break;
      }

      /*
      if ( UP_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (++pwr_TOP >= 100) { pwr_BOTTOM = 100; }
      }
      if ( DN_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (--pwr_TOP <= 0) { pwr_BOTTOM = 0; }
      }
      */

      if ( OK_KEY.isPressed() == SB_CLICK)
      {        
        beeper();
        updateScreen = true;
        saveProfile();
        reflowState = REFLOW_STATE_MENU_STEPS;
      }
      if ( ESC_KEY.isPressed() == SB_CLICK)
      {
        CancelState();
      }
      break;
      
////////////////////////////////////////
//устанавливаем количество шагов профиля
case REFLOW_STATE_MENU_STEPS:
      if (updateScreen)
      {
        //cls();
        tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
        tft.setCursor(col(1), row(4));
        tft.print("Profile:");
        tft.setCursor(col(9), row(4));
        tft.print(currentProfile);
        tft.setCursor(col(11), row(4));
        tft.print("Edit   ");
        tft.setCursor(col(1), row(6));
        tft.print("Profile Steps:    ");
        updateScreen = false;
     }
      
      tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
      tft.setCursor(col(15), row(6));
      tft.print(profileSteps);

      if ( UP_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (++profileSteps >= 5) { profileSteps = 1; } 
      } //см. saveEEPROM по кол-ву шагов
      if ( DN_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (--profileSteps <= 0) { profileSteps = 4; }
      }

      if ( OK_KEY.isPressed() == SB_CLICK)
      {        
        beeper();
        updateScreen = true;
        saveProfile();
        reflowState = REFLOW_STATE_MENU_STEP_TARGET;
      }
      if ( ESC_KEY.isPressed() == SB_CLICK)
      {
        CancelState();
      }
      break;

      
//устанавливаем температуру "Верхнего Нагревателя"
case REFLOW_STATE_MENU_STEP_TARGET:
      if (updateScreen) 
      {
        tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
        tft.setCursor(col(1), row(4));
        tft.print("SET TOP TEMP      ");
        tft.setCursor(col(1), row(6));
        tft.print("Step:  TEMP:      ");
        //tft.print(char(30));
        //tft.print("TEMP:   ");
        tft.setCursor(col(6), row(6));
        tft.print(editStep + 1);
        tft.setCursor(col(13), row(6));
        tft.print(temperatureStep[editStep]);
        tft.print("  ");
        updateScreen = false;
      }
      tft.setTextColor(ILI9341_RED, Bgcolor);
      //tft.print("  ");
      tft.setCursor(col(13), row(6));
      tft.print(temperatureStep[editStep]);
      tft.print("  ");

      switch (UP_KEY.isPressed())
      {
      case SB_CLICK:
        beeper();
        if (++temperatureStep[editStep] >= 270) { temperatureStep[editStep] = 270; }
        break;
      case SB_AUTO_CLICK:
        if (++temperatureStep[editStep] >= 270) { temperatureStep[editStep] = 270; }
        break;
      }
      switch (DN_KEY.isPressed())
      {
      case SB_CLICK:
        beeper();
        if (--temperatureStep[editStep] <= 0) { temperatureStep[editStep] = 0; }
        break;
      case SB_AUTO_CLICK:
        if (--temperatureStep[editStep] <= 0) { temperatureStep[editStep] = 0; }
        break;
      }

      /*
      if ( UP_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        //temperatureStep[editStep] = temperatureStep[editStep] + 1;
        if (++temperatureStep[editStep] >= 270) { temperatureStep[editStep] = 270; }
      }
      if ( DN_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        //temperatureStep[editStep] = temperatureStep[editStep] - 1;
        if (--temperatureStep[editStep] <= 0) { temperatureStep[editStep] = 0; }
      }
      */

      if ( OK_KEY.isPressed() == SB_CLICK)
      {        
        beeper();
        updateScreen = true;
        saveProfile();
        if (editStep + 1 == profileSteps)
        {
          editStep = 0;
          reflowState = REFLOW_STATE_MENU_STEP_RAMP;
        }
        else
        {
          editStep++;
        }
      }
      if ( ESC_KEY.isPressed() == SB_CLICK)
      {
        editStep = 0;
        CancelState();
      }

      break;

     


//устанавливаем скорость нагрева "Верхним Нагревателем"
case REFLOW_STATE_MENU_STEP_RAMP:

      if (updateScreen)
      {
        tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
        tft.setCursor(col(1), row(4));
        tft.print("HEAT speed TOP   ");
        tft.setCursor(col(1), row(6));
        tft.print("Step:  Ramp:       ");
        tft.setCursor(col(11), row(7)); tft.print(char(128));
        tft.print("C/sec");
        tft.setCursor(col(6), row(6));
        tft.print(editStep + 1);
        updateScreen = false;
      }
      tft.setTextColor(ILI9341_RED, Bgcolor);
      tft.setCursor(col(13), row(6));
      tft.print(rampRateStep[editStep] / 4);
      tft.print(" ");

       if ( UP_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (++rampRateStep[editStep] >= 12.)  //(только целые числа) максимальная скорость роста температуры делённая на 4
        {
          rampRateStep[editStep] = 12.;  //(только целые числа) максимальная скорость роста температуры делённая на 4
        }
      }
      if ( DN_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (--rampRateStep[editStep] <= 1.)  //(только целые числа) минимальная скорость роста температуры делённая на 4
        {
          rampRateStep[editStep] = 1.;  //(только целые числа) минимальная скорость роста температуры делённая на 4
        }
      }

      if ( OK_KEY.isPressed() == SB_CLICK)
      {        
        beeper();
        updateScreen = true;
        saveProfile();
        if (editStep + 1 == profileSteps)
        {
          editStep = 0;
        }
        reflowState = REFLOW_STATE_MENU_STEP_DWELL;
      }

      if ( ESC_KEY.isPressed() == SB_CLICK)
      {
        CancelState();
      }

      
      break;
      
///////////////////////////////////////
//устанавливаем время перехода на следующий шаг
case REFLOW_STATE_MENU_STEP_DWELL:

      if (updateScreen) 
      {
        tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
        tft.setCursor(col(11), row(7)); tft.print("      ");
        tft.setCursor(col(0), row(4));
        tft.print(" Time next step   ");
        tft.setCursor(col(1), row(6));
        tft.print("Step:"); tft.print(editStep + 1);
        tft.print(" Time:"); tft.print(dwellTimerStep[editStep]);
        tft.print("sec  ");
      }
      tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
      tft.setCursor(col(13), row(6));
      tft.print(dwellTimerStep[editStep]);
      tft.print("sec  ");
      //tft.print(" ");

       if ( UP_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        dwellTimerStep[editStep] = dwellTimerStep[editStep] + 5;
        if (dwellTimerStep[editStep] >= 95)
        {
          dwellTimerStep[editStep] = 95;
        }
      }
      if ( DN_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        dwellTimerStep[editStep] = dwellTimerStep[editStep] - 5;
        if (dwellTimerStep[editStep] <= 0)
        {
          dwellTimerStep[editStep] = 0;
        }
      }

      if ( OK_KEY.isPressed() == SB_CLICK)
      {        
        beeper();
        updateScreen = true;
        saveProfile();
        if (editStep + 1 == profileSteps)
        {
          editStep = 0;
          reflowState = REFLOW_STATE_MENU_BOTTOM_P;
        }
        else 
        {
          editStep++;
        }
      }
      if ( ESC_KEY.isPressed() == SB_CLICK)
      {
        editStep = 0;
        CancelState();
      }

      break;


      
      /////////////////////////////
//настройка "ПИД" нижнего нагревателя
case REFLOW_STATE_MENU_BOTTOM_P:
      if (updateScreen)
      {
        tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
        tft.setCursor(0*16, 1*48+48); //lcd.setCursor(2, 1);
        tft.print("        PID        ");       //lcd.print("Bottom Heat:      ");
        tft.setCursor(0*16+5, 2*48+48);//lcd.setCursor(0, 2);
        tft.print("                  ");//lcd.print("                  ");
        tft.setCursor(1*16, 2*48+48);//lcd.setCursor(3, 2);
        tft.print("Bottom Heater:");//lcd.print("Bottom Heater:");
        tft.setCursor(8*16, 3*48+48);//lcd.setCursor(8, 3);
        tft.print("P= ");//lcd.print("P=");
        tft.setCursor(11*16, 3*48+48);
        tft.print(kp2);//lcd.print(kp2);
        tft.print("  ");//lcd.print(" ");*/
        updateScreen = false;
      }
      tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
      tft.setCursor(11*16, 3*48+48);//lcd.setCursor(10, 3);
      tft.print(kp2);//lcd.print(kp2);
      tft.print("  ");//lcd.print("  ");

      kp2 = set_kPID(kp2);

      /*
      if ( UP_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (++kp2 >= 500) { kp2 = 500; }
      }
      if ( DN_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (--kp2 <= 0) { kp2 = 0; }
      }
      */

      if ( OK_KEY.isPressed() == SB_CLICK)
      {        
        beeper();
        updateScreen = true;
        saveProfile();
        reflowState = REFLOW_STATE_MENU_BOTTOM_I;
      }
      if ( ESC_KEY.isPressed() == SB_CLICK)
      {
        CancelState();
      }

      break;
      
///////////////////////////////  
case REFLOW_STATE_MENU_BOTTOM_I:
      tft.setCursor(0*16, 1*48+48); //lcd.setCursor(2, 1);
      tft.print("        PID        ");       //lcd.print("Bottom Heat:      ");
      tft.setCursor(8*16, 3*48+48);//lcd.setCursor(8, 3);
      tft.print("I= ");//lcd.print("I=");
      tft.setCursor(11*16, 3*48+48);//lcd.setCursor(10, 3);
      tft.print(ki2/10);//lcd.print(ki2);
      tft.print(" ");//lcd.print(" ");

      ki2 = set_kPID(ki2);

      /*
      if ( UP_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (++ki2 >= 500) { ki2 = 500; }
      }
      if ( DN_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (--ki2 <= 0) { ki2 = 0; }
      }
      */

      if ( OK_KEY.isPressed() == SB_CLICK)
      {        
        beeper();
        saveProfile();
        reflowState = REFLOW_STATE_MENU_BOTTOM_D;
      }
      if ( ESC_KEY.isPressed() == SB_CLICK)
      {
        CancelState();
      }
      
      break;
      
/////////////////////////////
case REFLOW_STATE_MENU_BOTTOM_D:
      tft.setCursor(0*16, 1*48+48); //lcd.setCursor(2, 1);
      tft.print("        PID        ");
      tft.setCursor(8*16, 3*48+48);//lcd.setCursor(8, 3);
      tft.print("D= ");//lcd.print("D=");
      tft.setCursor(11*16, 3*48+48);//lcd.setCursor(10, 3);
      tft.print(kd2);//lcd.print(kd2);
      tft.print(" ");//lcd.print(" ");

      kd2 = set_kPID(kd2);

      /*
      if ( UP_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (++kd2 >= 500) { kd2 = 500; }
      }
      if ( DN_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (--kd2 <= 0) { kd2 = 0; }
      }
      */

      if ( OK_KEY.isPressed() == SB_CLICK)
      {        
        beeper();
        saveProfile();
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_TOP_P;
      }
      if ( ESC_KEY.isPressed() == SB_CLICK)
      {
        CancelState();
      }

      break;
      
//////////////////////////////
//настройка "ПИД" верхнего нагревателя
case REFLOW_STATE_MENU_TOP_P:
      if (updateScreen)
      {
        tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
        tft.setCursor(0*16, 1*48+48); //lcd.setCursor(2, 1);
        tft.print("        PID        ");       //lcd.print("Bottom Heat:      ");
        tft.setCursor(0*16+5, 2*48+48);//lcd.setCursor(0, 2);
        tft.print("                  ");//lcd.print("                  ");
        tft.setCursor(3*16, 2*48+48);//lcd.setCursor(3, 2);
        tft.print("TOP Heater:   ");//lcd.print("Bottom Heater:");
        tft.setCursor(8*16, 3*48+48);//lcd.setCursor(8, 3);
        tft.print("P= ");//lcd.print("P=");
        tft.setCursor(11*16, 3*48+48);//lcd.setCursor(10, 3);
        tft.print(kp1);//lcd.print(kp1);
        tft.print(" ");//lcd.print(" ");*/
        updateScreen = false;
      }
      tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
      tft.setCursor(11*16, 3*48+48);//lcd.setCursor(10, 3);
      tft.print(kp1);//lcd.print(kp2);
      tft.print("  ");//lcd.print("  ");

      kp1 = set_kPID(kp1);

      /*
      if ( UP_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (++kp1 >= 500) { kp1 = 500; }
      }
      if ( DN_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (--kp1 <= 0) { kp1 = 0; }
      }
      */

      if ( OK_KEY.isPressed() == SB_CLICK)
      {        
        beeper();
        saveProfile();
        reflowState = REFLOW_STATE_MENU_TOP_I;
      }
      if ( ESC_KEY.isPressed() == SB_CLICK)
      {
        CancelState();
      }

      break;
      
///////////////////////////
case REFLOW_STATE_MENU_TOP_I:
        tft.setCursor(0*16, 1*48+48); //lcd.setCursor(2, 1);
        tft.print("        PID        ");       //lcd.print("Bottom Heat:      ");
        tft.setCursor(8*16, 3*48+48);//lcd.setCursor(8, 3);
        tft.print("I= ");//lcd.print("I=");
        tft.setCursor(11*16, 3*48+48);//lcd.setCursor(10, 3);
        tft.print(ki1/10);//lcd.print(ki1);
        tft.print(" ");//lcd.print(" ");

      ki1 = set_kPID(ki1);

      /*
      if ( UP_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (++ki1 >= 500) { ki1 = 500; }
      }
      if ( DN_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (--ki1 <= 0) { ki1 = 0; }
      }
      */

      if ( OK_KEY.isPressed() == SB_CLICK)
      {        
        beeper();
        saveProfile();
        reflowState = REFLOW_STATE_MENU_TOP_D;
      }
      if ( ESC_KEY.isPressed() == SB_CLICK)
      {
        CancelState();
      }

      break;
      
/////////////////////////////////
case REFLOW_STATE_MENU_TOP_D:
      tft.setCursor(0*16, 1*48+48); //lcd.setCursor(2, 1);
      tft.print("        PID        ");
      tft.setCursor(8*16, 3*48+48);//lcd.setCursor(8, 3);
      tft.print("D=");//lcd.print("D=");
      tft.setCursor(11*16, 3*48+48);//lcd.setCursor(10, 3);
      tft.print(kd1);//lcd.print(kd1);
      tft.print(" ");//lcd.print(" ");

      kd1 = set_kPID(kd1);

      /*
      if ( UP_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (++kd1 >= 500) { kd1 = 500; }
      }
      if ( DN_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (--kd1 <= 0) { kd1 = 0; }
      }
      */

      if ( OK_KEY.isPressed() == SB_CLICK)
      {        
        beeper();
        saveProfile();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      if ( ESC_KEY.isPressed() == SB_CLICK)
      {
        CancelState();
      }
      
      break;



//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
     
//"процесс пайки", рост температуры с заданной скоростью
case REFLOW_STATE_STEP_RAMP:
    //currentStep = 1;
    if (updateScreen)
    {
      tft.setTextColor(ILI9341_GREEN, Bgcolor); tft.setTextSize(fontsize3);
      tft.setCursor(col(mode_x), row(mode_y));
      tft.print("       ");
      prn_gr();/////////
      tft.setTextColor(ILI9341_BLACK, Bgcolor); tft.setTextSize(1);
      tft.setCursor(col_1(4), row_1(6));
      tft.print("PTN:"); tft.print(currentProfile);tft.print("  ");
      tft.print("Step:"); tft.print(currentStep);
      tft.print("/"); tft.print(profileSteps);
      tft.setCursor(col_1(4), row_1(7));
      tft.print("SPramp="); tft.print(setpointRamp);
      tft.setCursor(col_1(4), row_1(8));
      tft.print("Ramp="); tft.print(rampRateStep[currentStep-1]/4);tft.print(" ");      
      tft.print(char(128)); tft.print("C/sec");
      updateScreen = false;
     }
      tft.setTextColor(ILI9341_BLACK, Bgcolor); tft.setTextSize(1);
      tft.setCursor(col_1(4), row_1(10)); //25,82
      tft.setTextColor(ILI9341_BLUE, Bgcolor); tft.setTextSize(1);
      tft.print("BOTTOM="); tft.print(tc2);tft.print("/");
      tft.print(SP2); tft.print(char(128)); tft.print("C ");
      tft.print("PWM="); tft.print(pwr_BOTTOM); tft.print("%  ");
      tft.setTextColor(ILI9341_RED, Bgcolor); tft.setTextSize(1);
      tft.print("TOP="); tft.print(tc1);tft.print("/");
      tft.print(temperatureStep[currentStep - 1]); tft.print(char(128)); tft.print("C ");
      tft.print("PWM="); tft.print(pwr_TOP); tft.print("% ");
      tft.setCursor(col_1(4), row_1(7));
      tft.print("SPramp="); tft.print(setpointRamp);
      edit_pid();
      
    if (tc2>=Setpoint2 && !TopStart)  TopStart = true; //tc1
    if (TopStart == true) //если температура низа вышла на уставку
    { // включаем верхний нагреватель      
      if (flag == 0)//фиксируем стартовую температуру
      {
        startTemp = tc2;//tc1
        flag = 1;
      }
      //устанавливаем нужный шаг, до которой нагрета плата      
      if (startTemp > temperatureStep[currentStep -1])
      {
        for (x=1; startTemp > temperatureStep[currentStep - 1];currentStep++)
        {
          x++;
        }
      }      
      if (currentStep > x && flag == 1)
      {
        flag = 0;
        startTemp = temperatureStep[currentStep - 2];        
        flag = 1;
      }
      
//счётчик скорости роста температуры                  
      if ((currentMillis - previousMillis) > 4000 / rampRateStep[currentStep - 1])
      { //seconds counter
        previousMillis = currentMillis;
        counter++;// = counter + 1;
        setpointRamp = counter + startTemp;
        Setpoint1 = setpointRamp;
        //if ( setpointRamp - tc1 > 5 ) kp1++;
      }
    }
    
    if (setpointRamp >= temperatureStep[currentStep - 1]) 
      {//если достигли нужной температуры
        //tft.setTextColor(ILI9341_RED, Bgcolor);  tft.setTextSize(fontsize3);
        //tft.setCursor(col(4), row(6));
        //tft.print(temperatureStep[currentStep - 1]);
        reflowState = REFLOW_STATE_STEP;
      }
      if ( ESC_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        updateScreen = true;
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

//////////////////////////////////////////////////////
case REFLOW_STATE_STEP:
      Setpoint1 = temperatureStep[currentStep - 1];
      if (Input1 >= temperatureStep[currentStep - 1])
      {
        counter = 0;
        reflowState = REFLOW_STATE_STEP_DWELL;        
      }
      if ( ESC_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        updateScreen = true;
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

////////////////////////////////////////////////////////      
//считаем время перехода на следующий шаг
case REFLOW_STATE_STEP_DWELL:
      if (currentMillis - previousMillis > 1000) 
      {
        previousMillis = currentMillis;
        counter++;// = counter + 1;
      }
      if (counter == dwellTimerStep[currentStep - 1]) 
      {//если счётчик равен установленному времени
        counter = 0;
        setpointRamp = 0;
        if (profileSteps == currentStep) //если достигли последнего шага 
        {
          currentStep = 1;
          x = 1;      //устанавливаем переменную в исходное состояние
          flag = 0;   //после завершения профиля сбрасываем флаг
          reflowState = REFLOW_STATE_COMPLETE;
        }
        else //если шаг не последний
        {          
          currentStep++; //переходим на следующий шаг
          reflowState = REFLOW_STATE_STEP_RAMP;          
        }
      }
      if ( ESC_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        updateScreen = true;
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

//////////////////////////////////////////////      
//завершение пайки      
case REFLOW_STATE_COMPLETE:
      reflowStatus = REFLOW_STATUS_OFF;
      reflowState = REFLOW_STATE_IDLE;      
      updateScreen = true;
      break;
}
////////////////////////////////////////////////
////////////////////////////////////////////////
////////////////////////////////////////////////
//включение нагревателей
  if (reflowStatus == REFLOW_STATUS_ON)
  {
    if (millis() > nextRead2)
    {
      nextRead2 += GRAPHICS_SAMPLING_TIME;

      Input1 = max6675_read_temp (thermoCLK, thermoCStop, thermoSO);
      Input2 = max6675_read_temp (thermoCLK, thermoCStop, thermoSO);
      tc1 = Input1;
      tc2 = Input2;
      tc1_gr = (tc1 < 299) ? tc1 : 299;
      tc2_gr = (tc2 < 299) ? tc2 : 299;

      gy1 = map(tc1_gr, 0, 300, h-1, 91);
      gy2 = map(tc2_gr, 0, 300, h-1, 91);
      tft.drawLine(gx-1, gy1_prev, gx, gy1, ILI9341_RED);
      tft.drawLine(gx-1, gy2_prev, gx, gy2, ILI9341_BLUE);
      gy1_prev = gy1;
      gy2_prev = gy2;
      gx++;
      if(gx > (w - 2))
      {
        gx = 21;
        tft.fillRect(0, 90, w, h, Bgcolor);//cls
        prn_gr();/////////      
      }
      tft.setTextColor(ILI9341_BLACK, Bgcolor); tft.setTextSize(1);
      tft.setCursor(col_1(4), row_1(10)); //25,82
      tft.setTextColor(ILI9341_BLUE, Bgcolor); tft.setTextSize(1);
      tft.print("BOTTOM="); tft.print(tc2);tft.print("/");
      tft.print(SP2); tft.print(char(128)); tft.print("C ");
      tft.print("PWM="); tft.print(pwr_BOTTOM); tft.print("%  ");
      tft.setTextColor(ILI9341_RED, Bgcolor); tft.setTextSize(1);
      tft.print("TOP="); tft.print(tc1);tft.print("/");
      tft.print(temperatureStep[currentStep - 1]); tft.print(char(128)); tft.print("C ");
      tft.print("PWM="); tft.print(pwr_TOP); tft.print("% ");
      tft.setCursor(col_1(4), row_1(7));
      tft.print("SPramp="); tft.print(setpointRamp);

    }

    myPID1.SetTunings(kp1, ki1, kd1);
    myPID2.SetTunings(kp2, ki2, kd2);
    myPID1.SetOutputLimits(0, pwr_TOP);//установка минимального и максимального значения (от 0 до 100)
    myPID2.SetOutputLimits(0, pwr_BOTTOM);//которое будет передано на управление диммером
    myPID1.Compute();
    myPID2.Compute();
    attachInterrupt(0, Dimming, RISING); 
    // настроить порт прерывания(ISR0 - pin D2 or ISR1 - D3)
    if (!TopStart) Output1=0;
  }
  else
  {
    detachInterrupt(0);
    digitalWrite(RelayPin1, LOW);
    digitalWrite(RelayPin2, LOW);
    //Serial.print("rele2 = 0");Serial.print("rele2 = 0");
  }

}


void Dimming()
{
  OutPWR_TOP();
  OutPWR_BOTTOM();
}
////////////////////////////
void OutPWR_TOP()
{
     reg1 = Output1 + er1;
     if (reg1 < 50)
       {
        out1=LOW;
        er1 = reg1 ; // reg- переменная для расчетов
       }
     else
       {
         out1=HIGH;
         er1=reg1-100;
       }
   digitalWrite(RelayPin1,out1);//пин через который осуществляется дискретное управление
}
////////////////////////////
void OutPWR_BOTTOM()
{
     reg2 = Output2 + er2;
     if (reg2 < 50)
     {
       out2=LOW;
       er2 = reg2 ; // reg- переменная для расчетов
     }
     else
     {
       out2=HIGH;
       er2=reg2-100;
     }
   digitalWrite(RelayPin2,out2);//пин через который осуществляется дискретное управление
}


///////////////////////////////////////////////
void loadProfile()
{
  profileSteps = EEPROM.read((currentProfile - 1) * 29);
  Setpoint2 = EEPROM.read((currentProfile - 1) * 29 + 1);
  for (int i = 0; i < 9; i + 1) {
    rampRateStep[i] = EEPROM.read((currentProfile - 1) * 29 + i + 2);
    i++;
  }
  for (int i = 0; i < 9; i + 1) {
    dwellTimerStep[i] = EEPROM.read((currentProfile - 1) * 29 + i + 11) * 5;
    i++;
  }
  for (int i = 0; i < 9; i + 1) {
    temperatureStep[i] = EEPROM.read((currentProfile - 1) * 29 + i + 20);
    i++;
  }
  kp1 = EEPROM.read((currentProfile - 1) * 6 + 122);
  ki1 = EEPROM.read((currentProfile - 1) * 6 + 123);
  kd1 = EEPROM.read((currentProfile - 1) * 6 + 124);
  kp2 = EEPROM.read((currentProfile - 1) * 6 + 125);
  ki2 = EEPROM.read((currentProfile - 1) * 6 + 126);
  kd2 = EEPROM.read((currentProfile - 1) * 6 + 127);
  pwr_TOP = EEPROM.read((currentProfile - 1) * 6 + 128);
  pwr_BOTTOM = EEPROM.read((currentProfile - 1) * 6 + 129);
  return;
}

///////////////////////////////////////////////////////


void saveProfile()
{
  EEPROM.write((currentProfile - 1) * 29, profileSteps);
  EEPROM.write((currentProfile - 1) * 29 + 1, Setpoint2);
  for (int i = 0; i < 9; i + 1)
  {
    EEPROM.write(((currentProfile - 1) * 29 + i + 2), rampRateStep[i] );
    i++;
  }
  for (int i = 0; i < 9; i + 1) 
  {
    EEPROM.write(((currentProfile - 1) * 29 + i + 11), dwellTimerStep[i] / 5);
    i++;
  }
  for (int i = 0; i < 9; i + 1) 
  {
    EEPROM.write(((currentProfile - 1) * 29 + i + 20), temperatureStep[i]);
    i++;
  }
  EEPROM.write(((currentProfile - 1) * 6 + 122), kp1);
  EEPROM.write(((currentProfile - 1) * 6 + 123), ki1);
  EEPROM.write(((currentProfile - 1) * 6 + 124), kd1);
  EEPROM.write(((currentProfile - 1) * 6 + 125), kp2);
  EEPROM.write(((currentProfile - 1) * 6 + 126), ki2);
  EEPROM.write(((currentProfile - 1) * 6 + 127), kd2);
  EEPROM.write(((currentProfile - 1) * 6 + 128), pwr_TOP);
  EEPROM.write(((currentProfile - 1) * 6 + 129), pwr_BOTTOM);
  return;
}
//////////////////////////////////////////
/* при чтении темп. 1 раз/сек не особо нужен
float filter1(float val_1) {  //функция фильтрации показаний "Верхней" термопары
  Pc1 = P1 + varProcess1;
  G1 = Pc1/(Pc1 + varTerm1);
  P1 = (1-G1)*Pc1;
  Xp1 = Xe1;
  Zp1 = Xp1;
  Xe1 = G1*(val_1-Zp1)+Xp1; // "фильтрованное" значение
  return(Xe1);
}

float filter2(float val_2) {  //функция фильтрации показаний "Нижней" термопары
  Pc2 = P2 + varProcess2;
  G2 = Pc2/(Pc2 + varTerm2);
  P2 = (1-G2)*Pc2;
  Xp2 = Xe2;
  Zp2 = Xp2;
  Xe2 = G2*(val_2-Zp2)+Xp2; // "фильтрованное" значение
  return(Xe2);
}
*/

//отключил бузер при нажатии на кнопки (нервирует), кому надо раскоментируйте ниже 6 строк
void beeper()
{
  if (beeper_on)
  {
    tone(buzzerPin, 1045, 100);
  }  
}

void reflow_complete_ok()
{
  if (reflowState == REFLOW_STATE_COMPLETE || alarmOn) {
    if (i < 2 && ESC_KEY.isPressed() == SB_NONE)
    {
      alarmOn = true;
      tone(buzzerPin, 1046, 100);
      delay(100);
      tone(buzzerPin, 1046, 100);
      delay(100);
      tone(buzzerPin, 1046, 100);
      delay(100);
      tone(buzzerPin, 1046, 100);
      delay(100);
      i++;
    }
    else
    {
      i = 0;
      alarmOn = false;
    }
  }

}

///////////////////////////
void prn_gr()
{
  tft.setTextWrap(true); // вернуть перенос строк
  tft.setTextSize(3);
  tft.setCursor(col(0), row(3)+16);
  for (uint8_t i = 0; i < 127; i++)
  {
    tft.print(" ");
  }
  tft.setTextWrap(false); // отменить перенос строк
  tft.setTextSize(1); tft.setTextColor(ILI9341_BLACK, Bgcolor);
  tft.setCursor(col_1(1), row_1(10));
  tft.print(char(128)); tft.print("C");
  for (uint8_t i = 1; i < 7; i++)
  {
    tft.setCursor(0, h - i*25);
    tft.print(i*50);
    tft.drawFastHLine(18, h - i*25, w-18, ILI9341_YELLOW);    
  }
  tft.drawRect(20, h-150, w-21, h-91, ILI9341_MAGENTA);
}
////////////////////////////

void edit_pid()
{
  tft.setTextSize(1); tft.setTextColor(ILI9341_RED, Bgcolor);
  tft.setCursor(col_1(30), row_1(6));
  tft.print(case0 ? "*" : " ");
  tft.print(char(31)); tft.print("P="); tft.print(kp2);//низ
  tft.setCursor(col_1(30), row_1(7));
  tft.print(case1 ? "*" : " ");
  tft.print(char(31)); tft.print("I="); tft.print(ki2/10);//низ
  tft.setCursor(col_1(30), row_1(8));
  tft.print(case2 ? "*" : " ");
  tft.print(char(31)); tft.print("D="); tft.print(kd2);//низ
  tft.setCursor(col_1(40), row_1(6));
  tft.print(case3 ? "*" : " ");
  tft.print(char(30)); tft.print("P="); tft.print(kp1);//верх
  tft.setCursor(col_1(40), row_1(7));
  tft.print(case4 ? "*" : " ");
  tft.print(char(30)); tft.print("I="); tft.print(ki1/10);//верх
  tft.setCursor(col_1(40), row_1(8));
  tft.print(case5 ? "*" : " ");
  tft.print(char(30)); tft.print("D="); tft.print(kd1);//верх
  

  if ( OK_KEY.isPressed() == SB_CLICK)  {        
    beeper();
    if ( ++ed_pid > 5 ) ed_pid = 0;
    //updateScreen = true;
  }
  
  switch (ed_pid){
  case 0:
    case0 = true;  case1 = false; case2 = false;
    case3 = false; case4 = false; case5 = false;
    kp2 = edit_kPID(kp2);
  break;
  
  case 1:
    case0 = false; case1 = true;  case2 = false;
    case3 = false; case4 = false; case5 = false;
    ki2 = edit_kPID(ki2);
  break;
  
  case 2:
    case0 = false; case1 = false; case2 = true;
    case3 = false; case4 = false; case5 = false;
    kd2 = edit_kPID(kd2);
  break;
  
  case 3:
    case0 = false; case1 = false; case2 = false;
    case3 = true;  case4 = false; case5 = false;
    kp1 = edit_kPID(kp1);
  break;
  
  case 4:
    case0 = false; case1 = false; case2 = false;
    case3 = false; case4 = true;  case5 = false;
    ki1 = edit_kPID(ki1);
  break;
  
  case 5:
    case0 = false; case1 = false; case2 = false;
    case3 = false; case4 = false; case5 = true;
    kd1 = edit_kPID(kd1);
  break;
  }
  
}

/*
 *       if ( UP_KEY.isPressed() == SB_CLICK) {
        beeper();
        Setpoint2 += 5;
        //Setpoint2 = Setpoint2 + 5;
        if (Setpoint2 >= 250) { Setpoint2 = 250; }
      }
      if ( DN_KEY.isPressed() == SB_CLICK) {
        beeper();
        Setpoint2 -= 5;
        //Setpoint2 = Setpoint2 - 5;
        if (Setpoint2 <= 30) { Setpoint2 = 30; }
      }

      if ( OK_KEY.isPressed() == SB_CLICK)  {        
        beeper();
        updateScreen = true;
        saveProfile();
        reflowState = REFLOW_STATE_MENU_BOTTOM_PWR;
      }
      if ( ESC_KEY.isPressed() == SB_CLICK) {
        updateScreen = true;
        saveProfile();
        reflowState = REFLOW_STATE_IDLE;
      }
       if ( UP_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (++kp2 >= 500) { kp2 = 500; }
      }
      if ( DN_KEY.isPressed() == SB_CLICK)
      {
        beeper();
        if (--kp2 <= 0) { kp2 = 0; }
      }

 */
void CancelState() {
        beeper();
        updateScreen = true;
        saveProfile();
        reflowState = REFLOW_STATE_IDLE;
}

int set_kPID(int kPID)
{
      switch (UP_KEY.isPressed())
      {
      case SB_CLICK:
        beeper();
        if (++kPID >= 50) kPID = 50;
        break;
      case SB_AUTO_CLICK:
        if (++kPID >= 50) kPID = 50;
        break;
      }
      switch (DN_KEY.isPressed())
      {
      case SB_CLICK:
        beeper();
        if (--kPID <= 0) kPID = 0;
        break;
      case SB_AUTO_CLICK:
        if (--kPID <= 0) kPID = 0;
        break;
      }
    return kPID;
}

int edit_kPID(int kPID)
{
    if ( UP_KEY.isPressed() == SB_CLICK)
    {
      beeper();
      if (++kPID >= 100) { kPID = 100; }
      saveProfile();
    }
    if ( DN_KEY.isPressed() == SB_CLICK)
    {
      beeper();
      if (--kPID <= 0) { kPID = 0; }
      saveProfile();
    }
    return kPID;
}
